/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#if !defined(HARK_BASE_COLLECTOR_H_INCLUDED)
#define HARK_BASE_COLLECTOR_H_INCLUDED 1

#include "common.h"

#include "Node.h"
#include "Exception.h"
#include <map>

namespace HARK
{
    class Collector : public Node
    {
    protected:
	Collector();

    public:
	Collector(const std::string &nodeName, const ParameterSet &params);

	virtual void initialize();

	virtual ObjectRef getOutput(int output_id, int count);

	virtual ObjectRef getOutputNamed (const std::string &outputName, int count);

	virtual bool hasOutput(int output_id) const;

	virtual void request(int outputID, const ParameterSet &req);

	virtual void requestAll(const ParameterSet &req);

    protected:
	virtual int translateInput(const std::string &inputName);
	virtual int translateOutput(const std::string &inputName);

    };
}

#endif

/* end of file */
