/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#if !defined(HARK_BASE_EXCEPTION_H_INCLUDED)
#define HARK_BASE_EXCEPTION_H_INCLUDED 1

#include "common.h"

#include <iostream>
#include <string>
#include "BaseException.h"

namespace HARK
{
    class NodeNotFoundException : public BaseException
    {
    public:
	NodeNotFoundException(std::string name);
	virtual void print(std::ostream &out = std::cerr) const;

    private:
	std::string nodeName;
    };

    class  NoSinkNodeException : public BaseException
    {
    public:
	NoSinkNodeException(int value = 0);
	virtual void print(std::ostream &out = std::cerr) const;

    private:
	int errorNo;
    };

    class  NoInputNodeException : public BaseException
    {
    public:
	NoInputNodeException(int value = 0);
	virtual void print(std::ostream &out = std::cerr) const;

    private:
	int errorNo;
    };

    class FactoryNotFoundException : public BaseException
    {
    public:
	FactoryNotFoundException(std::string name);
	virtual void print(std::ostream &out = std::cerr) const;

    private:
	std::string factoryName;
    };

}

#endif

/* end of file */
