/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#if !defined(HARK_BASE_IF_H_INCLUDED)
#define HARK_BASE_IF_H_INCLUDED 1

#include "common.h"

#include "Node.h"

namespace HARK
{
    class IF : public Node
    {
    public:
	IF(const std::string &nodeName, const ParameterSet &params);

	ObjectRef getOutput(int output_id, int count);

    private:
	int _inputID;
	int _thenID;
	int _elseID;
	int _outputID;
	bool _pullAnyway;

    };

}

#endif

/* end of file */
