/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#if !defined(HARK_BASE_INPUTSTREAM_H_INCLUDED)
#define HARK_BASE_INPUTSTREAM_H_INCLUDED 1

#include "common.h"

#include "BufferedNode.h"

namespace HARK
{
    class InputStream : public BufferedNode
    {
    protected:
	enum StreamType {
	    fd, fptr, cpp
	};

	int        _outputID;
	int        _inputID;
	StreamType _type;
	int        _retry;

    public:
	InputStream(const std::string &nodeName, const ParameterSet &params);

	void calculate(int output_id, int count, Buffer &out);

    protected:
	InputStream();
	
	NO_ORDER_NODE_SPEEDUP(InputStream)
    };
}

#endif

/* end of file */
