/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#if !defined(HARK_BASE_STR_TIMELOG_HPP_INCLUDED)
#define HARK_BASE_STR_TIMELOG_HPP_INCLUDED 1

#include <string>
#include <chrono>
#include <time.h>
#include <vector>
#include <sstream>
#include <iostream>
#include <iomanip>

//using namespace std;

static std::string _TimeLog(const std::chrono::system_clock::time_point& t){
    std::chrono::microseconds dus = std::chrono::duration_cast<std::chrono::microseconds>(t.time_since_epoch());
    std::chrono::seconds ds = std::chrono::duration_cast<std::chrono::seconds>(t.time_since_epoch());

    std::time_t timet = (time_t)ds.count();
    int us = dus.count() - ds.count() * 1e6;
    const tm* lt = std::localtime(&timet);

    std::string strLog;
    std::ostringstream sout;
    std::vector<std::string> strMonList = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
                                           "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

    sout << (lt->tm_year + 1900)
         << "-" << strMonList[lt->tm_mon]
         << "-" << std::setfill('0') << std::setw(2) << lt->tm_mday
         << " " << std::setfill('0') << std::setw(2) << lt->tm_hour
         << ":" << std::setfill('0') << std::setw(2) << lt->tm_min
         << ":" << std::setfill('0') << std::setw(2) << lt->tm_sec
         << "." << std::setfill('0') << std::setw(6) << us;
    strLog = sout.str();
    return strLog;
}

#endif
