/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#if !defined(HARK_BASE_OBJECT_PARAM_H_INCLUDED)
#define HARK_BASE_OBJECT_PARAM_H_INCLUDED 1

#include "common.h"

#include "ParameterSet.h"
#include "ObjectRef.h"
#include <string>
#include <vector>

namespace HARK
{
    class ObjectParam
    {
    public:
	static const std::vector<std::string> &allTypes(bool allowSubnetParam = true);
	static ObjectRef stringParam(const std::string &type, const std::string &value, const ParameterSet &param);
    };
}

#endif

/* end of file */
