/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#if !defined(HARK_BASE_TYPEMAP_H_INCLUDED)
#define HARK_BASE_TYPEMAP_H_INCLUDED 1

#include "common.h"

#include <algorithm>
#include <map>
#include <typeinfo>

struct compare_const_type_info_ptr : public std::binary_function<const std::type_info *, const std::type_info *, bool> {
    bool operator()(const std::type_info *lhs, const std::type_info *rhs) const
    {
        return lhs->before(*rhs);
    }
};

template<typename T>
class TypeMap : public std::map<const std::type_info *, T, compare_const_type_info_ptr >
{
};

#endif

/* end of file */
