/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#include "Exception.h"

namespace HARK
{
    NodeNotFoundException::NodeNotFoundException(std::string name) :
	nodeName(name)
    {
    }
    
    void
    NodeNotFoundException::print(std::ostream &out) const
    {
	out << "NodeNotFoundException occured, nodeName: " << this->nodeName << std::endl;
    }
    
    NoSinkNodeException::NoSinkNodeException(int value) :
	errorNo(value)
    {
    }

    void
    NoSinkNodeException::print(std::ostream &out) const
    {
	out << "NoSinkNodeException occured, errorNo: " << this->errorNo << std::endl;
    }

    NoInputNodeException::NoInputNodeException(int value) :
	errorNo(value)
    {
    }

    void
    NoInputNodeException::print(std::ostream &out) const
    {
	out << "NoInputNodeException occured, errorNo: " << this->errorNo << std::endl;
    }

    FactoryNotFoundException::FactoryNotFoundException(std::string name) :
	factoryName(name)
    {
    }

    void
    FactoryNotFoundException::print(std::ostream &out) const
    {
	out << "FactoryNotFoundException occured, factoryName: "<<  this->factoryName << std::endl;
    }
}

/* end of file */
