/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#include "IterCount.h"

namespace HARK
{
    DECLARE_NODE(IterCount);
    /*Node

     * @name IterCount
     * @category Logic
     * @description Get the iterator count (iteration number)

     * @output_name OUTPUT
     * @output_description The iteration count
     * @output_type int

     END*/

    IterCount::IterCount(const std::string &nodeName, const ParameterSet &params) :
	Node(nodeName,params)
    {
        this->_outputID = this->addOutput("OUTPUT");
    }

    ObjectRef
    IterCount::getOutput(int output_id, int count)
    {
        return ObjectRef(Int::alloc(count));
    }

}

/* end of file */
