/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#include "Matrix.h"

#include "Object.h"
#include "ObjectParser.h"
#include "ObjectRef.h"
#include "operators.h"
#include <complex>

namespace HARK
{
    DECLARE_TYPE(Matrix<bool>);
    DECLARE_TYPE(Matrix<int>);
    DECLARE_TYPE(Matrix<float>);
    DECLARE_TYPE(Matrix<double>);
    DECLARE_TYPE(Matrix<ObjectRef>);
    DECLARE_TYPE(Matrix<std::string>);
    DECLARE_TYPE(Matrix<String>);
    DECLARE_TYPE2("Matrix", Matrix<float>);
    DECLARE_TYPE2("Matrix<complex<float>>",Matrix<std::complex<float> >);
    DECLARE_TYPE2("Matrix<complex<double>>",Matrix<std::complex<double> >);
}

/* end of file */
