/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#include "NOP.h"

namespace HARK
{
    DECLARE_NODE(NOP);
    /*Node
     *
     * @name NOP
     * @category General
     * @description Pass Through (no operation)
     *
     * @input_name INPUT
     * @input_description The input
     *
     * @output_name OUTPUT
     * @output_description The output = The input
     *
     END*/

    NOP::NOP(const std::string &nodeName, const ParameterSet &params)
        : BufferedNode(nodeName, params)
    {
	this->_inputID  = this->addInput("INPUT");
	this->_outputID = this->addOutput("OUTPUT");
    }

    void
    NOP::calculate(int output_id, int count, Buffer &out)
    {
        ObjectRef input1Value = this->getInput(this->_inputID, count);
        out[count] = input1Value;
    }
}

/* end of file */

