/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#include "Vector.h"

#include "Object.h"
#include "ObjectParser.h"
#include "ObjectRef.h"
#include "operators.h"
#include <complex>

namespace HARK
{
    DECLARE_TYPE(Vector<float>);
    DECLARE_TYPE(Vector<double>);
    DECLARE_TYPE(Vector<int>);
    DECLARE_TYPE(Vector<ObjectRef>);
    DECLARE_TYPE(Vector<std::string>);
    DECLARE_TYPE(Vector<String>);
    DECLARE_TYPE2("Vector", Vector<float>);
    DECLARE_TYPE2("Vector<complex<float>>", Vector<std::complex<float> >);
    DECLARE_TYPE2("Vector<complex<double>>", Vector<std::complex<double> >);
}

/* end of file */
